#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll inf=1e18;
int main()
{
    int n,m;
    scanf("%i%i",&n,&m);
    int a[n+1][m+1];
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            scanf("%i",&a[i][j]);
        }
    }
    int t;
    cin>>t;
    while(t--)
    {
        int x,y;
        cin>>x>>y;
        ll dp[n+1][m+1];
        for(int i=1;i<=n;i++) dp[i][0]=inf;
        for(int i=1;i<=m;i++) dp[0][i]=inf;
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=m;j++)
            {
                if(i==1 && j==1){dp[1][1]=a[1][1];continue;}
                if(i==x && j==y){dp[i][j]=inf;continue;}
                dp[i][j]=min(dp[i-1][j],dp[i][j-1])+a[i][j];
            }
        }
        printf("%lld\n",dp[n][m]);
    }
    return 0;
}